import { BaseBatchUpdateStatusManager } from 'src/core/modules/domain/usecase/managers/base-batch-update-status.manager';
import { TimeGroupEntity } from '../../entities/time-group.entity';
import {
  EventTopics,
  validateRelations,
} from 'src/core/strings/constants/interface.constants';
import { TimeGroupModel } from '../../../data/models/time-group.model';
import { TimeGroupChangeStatusEvent } from '../../entities/event/time-group-change-status.event';
import { BatchResult } from 'src/core/response/domain/ok-response.interface';
import { Injectable } from '@nestjs/common';

@Injectable()
export class BatchConfirmTimeGroupManager extends BaseBatchUpdateStatusManager<TimeGroupEntity> {
  validateData(data: TimeGroupEntity): Promise<void> {
    return;
  }

  beforeProcess(): Promise<void> {
    return;
  }

  afterProcess(): Promise<void> {
    return;
  }

  get validateRelations(): validateRelations[] {
    return [];
  }

  get entityTarget(): any {
    return TimeGroupModel;
  }

  get eventTopics(): EventTopics[] {
    return [
      {
        topic: TimeGroupChangeStatusEvent,
      },
    ];
  }

  getResult(): BatchResult {
    return this.result;
  }
}
